
#ifdef _WIN32 
#include <windows.h>
#endif

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <GL/gl.h>      /* Include definitions of the OpenGL API */
#include <GL/glut.h>     /* Include definitions of the GLUT API */

#ifndef M_PI
#define	M_PI		3.14159265358979323846	/* pi */
#endif

#define GLUT_DRAG        2
int _button;

int SPGN=1;

extern void redisplay  ( void ) ;
extern void Spezi  (int k,int x, int y ) ;
extern void Keyb  (unsigned char k,int x, int y ) ;
extern void myMouse( int button, int state, int x, int y );
extern void _Motion( int x, int y );
extern void initCamera ( void ) ;
extern int ausloeschung(int h,int k,int l,int spgn);
void glRotateL(int typ, const double dang, const double x, const double y, const double z )
{
  double mat[4][4];
  const double s = sin(dang*M_PI/180);
  const double c = cos(dang*M_PI/180);
  double T;
  glGetDoublev( typ, (double*)mat );

  if( x!=0.0 ){
    T = mat[0][1];
    mat[0][1] = c*T - s*mat[0][2];
    mat[0][2] = s*T + c*mat[0][2];
    T=mat[1][1];
    mat[1][1] = c*T - s*mat[1][2];
    mat[1][2] = s*T + c*mat[1][2];
    T=mat[2][1];
    mat[2][1] = c*T - s*mat[2][2];
    mat[2][2] = s*T + c*mat[2][2];
  }else if( y!=0.0 ){
    T=mat[0][2];
    mat[0][2] = c*T - s*mat[0][0];
    mat[0][0] = s*T + c*mat[0][0];
    T=mat[1][2];
    mat[1][2] = c*T - s*mat[1][0];
    mat[1][0] = s*T + c*mat[1][0];   
    T=mat[2][2];
    mat[2][2] = c*T - s*mat[2][0];
    mat[2][0] = s*T + c*mat[2][0];
  }else if( z!=0.0 ){
    T=mat[0][0];
    mat[0][0] = c*T - s*mat[0][1];
    mat[0][1] = s*T + c*mat[0][1];
    T=mat[1][0];
    mat[1][0] = c*T - s*mat[1][1];
    mat[1][1] = s*T + c*mat[1][1];
    T=mat[2][0];
    mat[2][0] = c*T - s*mat[2][1];
    mat[2][1] = s*T + c*mat[2][1];
  }

  glLoadMatrixd((double*)mat); 
}

void objekte(void){
  int maxh=20,maxk=20,maxl=20,minh=-20,mink=-20,minl=-20;
   
  bas=glGenLists(3);  
 {
  glNewList(bas,GL_COMPILE);
   glPointSize(2);   
    for (int h=minh;h<=maxh;h++)
     for (int k=mink;k<=maxk;k++)
      for (int l=minl;l<=maxl;l++)
   	   if ((LAM >=	    
	      sqrt((xs[0]*h+ys[0]*k+zs[0]*l)*(xs[0]*h+ys[0]*k+zs[0]*l)+
		       (xs[1]*h+ys[1]*k+zs[1]*l)*(xs[1]*h+ys[1]*k+zs[1]*l)+
		       (xs[2]*h+ys[2]*k+zs[2]*l)*(xs[2]*h+ys[2]*k+zs[2]*l))))
	   {
	     glPushMatrix();	     
	     if ((h==1)) glColor4d(0,1,.0,1); 
         else if ((h==-1)) glColor4d(1,0,1,1); 
         else if ((k==1)) glColor4d(1.0,0.7,0,1); 
         else if ((k==-1)) glColor4d(0,0,1,1); 
         else glColor4d(1,0,0,0.2);	     
         glBegin(GL_POINTS);
          if (ausloeschung(h,k,l,SPGN)); 
          else glVertex3d(xs[0]*h+ys[0]*k+zs[0]*l, xs[1]*h+ys[1]*k+zs[1]*l,  xs[2]*h+ys[2]*k+zs[2]*l);
         glEnd();
	     glPopMatrix();
	   }   
   glPointSize(1.0);
  glEndList();
 }  
 glNewList(bas+1,GL_COMPILE);
  glBegin(GL_LINES);
   glColor4d(1.0,0.0,0.0,1.0);//rote X-Achse
   glVertex3d(0.0,0,0);
   glVertex3d(xs[0]*20,xs[1]*20,xs[2]*20);
  
   glColor4d(0.0,1.0,0.0,1.0);//gruene Y-Achse
   glVertex3d(0.0,0,0);
   glVertex3d(ys[0]*20,ys[1]*20,ys[2]*20);

   glColor4d(0.0,0.0,1.0,1.0);//Blaue Z-Achse
   glVertex3d(0.0,0,0);
   glVertex3d(zs[0]*20,zs[1]*20,zs[2]*20);
  glEnd();
 glEndList();
  
 glNewList(bas+2,GL_COMPILE);
  glPushMatrix();
  glLoadIdentity();
  glColor4d(0.0,0.3,0.0,0.6); 
  glTranslated(LAM/2, 0.0, 0.0);
  glutSolidSphere(LAM/2,60,32);//Ewald-Kugel
  glPopMatrix();
 glEndList();

}

int ausloeschung(int h,int k,int l,int spgn){
  int ext=0;
  switch (spgn){
  case 11:;  
  case 4: if (!h && !l) ext=((k %2)!=0)?1:ext;
    break;  
  case 7:;
  case 13:if (!k) ext=((h %2)!=0)?1:ext;
    break;  
  case 14:
    if (!k) ext=((l %2)!=0)?1:ext;
    if (!h && !l) ext=((k %2)!=0)?1:ext;
    break;  
  case 5:;
  case 8:;
  case 12:
    ext=(((k+k)%2)!=0)?1:ext;
    if (!k) ext=((h %2)!=0)?1:ext; 
    if (!h && !l) ext=((k %2)!=0)?1:ext;
    break;
  case 9:
  case 15:
    ext=(((k+k)%2)!=0)?1:ext;
    if (!k) ext=((h %2)!=0)?1:ext; 
    if (!k) ext=((l %2)!=0)?1:ext; 
    if (!h && !l) ext=((k %2)!=0)?1:ext;
  case 19:
    if (!h && !k) ext=((l %2)!=0)?1:ext; 
    if (!k && !l) ext=((h %2)!=0)?1:ext; 
    if (!h && !l) ext=((k %2)!=0)?1:ext; 
    break;
  case 61:
    if (!h) ext=((k %2)!=0)?1:ext;
    if (!k) ext=((l %2)!=0)?1:ext;
    if (!l) ext=((h %2)!=0)?1:ext;
    if (!h && !k) ext=((l %2)!=0)?1:ext;
    if (!k && !l) ext=((h %2)!=0)?1:ext;
    if (!h && !l) ext=((k %2)!=0)?1:ext;
    break;
  case 146:
    ext=((k+l-h)%3!=0)?1:ext;
    break;
  default: ext=0;
  }  
  return ext;
}

void Keyb  (unsigned char k,int x, int y ) {
    if ((k==27)||(k=='q')) {
        glutSetWindow(hauptfenster);
        if (weiWi) glutDestroyWindow(weiWi);    
        if (drehWi) glutDestroyWindow(drehWi);    
        glutDestroyWindow(hauptfenster);    
        exit(0);
        }
  switch (k){
  case 'x':
      achsen=!achsen; 
      break;
  case 'a':    
      glRotateL(GL_PROJECTION,1,0,1,0);
      glMatrixMode( GL_MODELVIEW ) ;
      break;
  case 'd':    
      glRotateL(GL_PROJECTION,-1,0,1,0);
      glMatrixMode( GL_MODELVIEW ) ;
      break;
  case 'w':
      glRotateL(GL_PROJECTION,1,1,0,0);
      glMatrixMode( GL_MODELVIEW ) ;
      break;
  case 's':    
      glRotateL(GL_PROJECTION,-1,1,0,0);
      glMatrixMode   ( GL_MODELVIEW ) ;
      break;
  }
  glutPostRedisplay ();
}

void myMouse( int button, int state, int x, int y )
{
  _button=button;
  static int xs=0, ys=0;
  if( button == GLUT_LEFT_BUTTON ){
    if( state == GLUT_DOWN ) {
      xs = x, ys = y;
    }
    if( state == GLUT_DRAG ){      
      glRotateL(GL_PROJECTION_MATRIX,(y - ys) / -2.0, 1.0, 0.0, 0.0 );
      glRotateL(GL_PROJECTION_MATRIX,(x - xs) / -2.0, 0.0, 1.0, 0.0 );      
      glMatrixMode   ( GL_MODELVIEW ) ;
      glutPostRedisplay();
      xs=x;
      ys=y;
    }
  }
  if( button == GLUT_MIDDLE_BUTTON ){
    if( state == GLUT_DOWN ) {
      xs = x, ys = y;
    }
    if( state == GLUT_DRAG ){      
      glRotateL(GL_PROJECTION_MATRIX,(x - xs) / -2.0, 0.0, 0.0, 1.0 );       
      glMatrixMode   ( GL_MODELVIEW ) ;
      glutPostRedisplay();
      xs=x;
      ys=y;
    }
  }
}
void _Motion( int x, int y ){
  myMouse( _button, GLUT_DRAG, x, y );
}

void drehMouse( int button, int state, int x, int y )
{
  if ((button==GLUT_LEFT_BUTTON)){
    drehauf=0;    
    weiauf=0;    
      
  }
  if ((button==GLUT_RIGHT_BUTTON)){
    rcnt=0;
    glutPostRedisplay();
  }
}

void drehDisplay(void)
{
  if (!drehauf) {glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT);
}
  drehauf=1;
  double R[3],Y,Z;
  glPushMatrix();
  glColor3f(0.0,0.0,0.0);
  glLoadIdentity();
  glBegin(GL_LINES);
   glVertex2d(-1,0.0);
   glVertex2d(1,0.0);
   glVertex2d(0,1.0);
   glVertex2d(0,-1.0);
  glEnd();
  glPopMatrix();
  for (int i=0;i<rcnt; i++) {
    glLoadIdentity();
    glColor3f(1.0,0.0,0.0);    
    glPointSize(3);
    glBegin(GL_POINTS);
    glVertex3d(0,0,0);
    glEnd();
    glPointSize(1);
}
  glFlush();
  glutSwapBuffers();
}